Subject: Re: Problem with PCI bus rescan on 460EX

From: Felix Radensky <[email-masked]>
Date: Sat, 13 Mar 2010 01:04:37 +0200

Hello Kenji-san,

Kenji Kaneshige wrote:
> I'm not sure, but I guess pci_setup_bridge() didn't update IO base/limit
> and Mem base/limit of the bridge (0000:00:02.0) because of the following
> lines.
>
> static void pci_setup_bridge(struct pci_bus *bus)
> {
>        struct pci_dev *bridge = bus->self;
>        struct resource *res;
>        struct pci_bus_region region;
>        u32 l, bu, lu, io_upper16;
>
>        if (pci_is_enabled(bridge))    
> <===============================               
>                return;            <===============================
>
>        dev_info(&bridge->dev, "PCI bridge to [bus %02x-%02x]\n",
>                 bus->secondary, bus->subordinate);
>     ...
>
> It seems the bridge was already enabled by 
> pci_assign_unassigned_resources()
> at boot time. Does removing those lines make any change?
>

Yes, with these lines removed bridge memory window is properly allocated.
For some reason bridge memory is disabled, but if I enable it via 
setpci, and
also enable device memory, then everything works fine. If the system is 
booted
when device behind the bridge is plugged in, bridge memory is enabled.

Thanks a lot for your help.

Felix.